<script setup lang="ts">
import type { Product } from '@/types/Product';

import { useProductStore } from '@/stores/product';
import { computed, ref, type Ref } from 'vue';
import { inject } from 'vue';

const productStore = useProductStore()
const dialog = inject<Ref<boolean>>('dialogItemDetail')
const form = ref(false)
const editedProduct = inject<Ref<Product>>('editedProduct') ?? {
id: 0,
name: '',
price: 0,
category: 1,
type: 'H',
gsize: 'S',
sweet_level: '100%'
}

const getTypeOptions = ['H', 'C', 'F'];
const allowedTypes = computed(() => {
  const currentType = productStore.editedProduct.type;
  
  // ตรวจสอบว่า currentType เป็น string และไม่ใช่ string ว่าง
  const selectedTypes = typeof currentType === 'string' && currentType.length > 0 ?
    Array.from(currentType) :
    [currentType.charAt(0)]; // หรือค่าตั้งต้นที่คุณต้องการ

  // ทำให้ค่าเริ่มต้นเป็นอักษรตัวแรกของ currentType ทั้งหมด
  return selectedTypes.length > 0 ? selectedTypes : getTypeOptions;
});
const selected = inject<(p: Product) => void>('selected')?? function(){}
const closeDialog = inject<() => void>('closeDialog')?? function(){}
</script>

<template>
    <v-dialog v-model="dialog" persistent width="400">
      
            <v-card>
              <v-card-title>{{ productStore.editedProduct.type.charAt(0) }}
                <span class="text-h5">Item Detail</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refform" v-model="form">
                  <v-container>
                    <v-row>
                      <v-col cols="12" style="font-size: 40px; text-align: center; padding: 0;">
                        {{ editedProduct.name }}
                      </v-col>
                      <v-col cols="12" sm="12" style="padding: 0;">
                        <v-combobox label="Type" :items="allowedTypes"
                          v-model="editedProduct.type"></v-combobox>
                      </v-col>
                      <v-col cols="12" sm="12" style="padding: 0;">
                        <v-combobox label="Size" :items="['S','M','L']"
                          v-model="editedProduct.gsize"></v-combobox>
                      </v-col>
                      <v-col cols="12" sm="12" style="padding: 0;">
                        <v-combobox label="Sweet Level" :items="['100%', '75%', '50%','25%','0%']"
                          v-model="editedProduct.sweet_level"></v-combobox>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog">
                  Close
                </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="selected(editedProduct)">
                  Save
                </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
</template>